#include "sensor_commands.h"

namespace sensor_commands {
  const uint8_t MAX_CALLBACKS = 20;
  uint8_t callbacks_count = 0;
// A callback contains both a function and a pointer to arbitrary data
// that will be passed as argument to the function.
  struct Callback {
    Callback(void (*f)(void*) = 0, void *d = 0) :
        function(f), data(d) {
    }
    void (*function)(void*);
    void *data;
  };

  Callback callbacks[MAX_CALLBACKS];

  void defineCallback(void (*f)(void*), void *d) {
    if (callbacks_count < MAX_CALLBACKS) {
      callbacks[callbacks_count++] = Callback(f, d);
    } else {
      Serial.println("OH NOOEEEESSS!!!! TOO MANY CALLBACKS");
    }
  }

  void run() {
    // Test all the callbacks.
    for (uint8_t i = 0; i < callbacks_count; i++) {
      callbacks[i].function(callbacks[i].data);
    }
  }
}
